VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8295
   LinkTopic       =   "Form1"
   ScaleHeight     =   2415
   ScaleWidth      =   8295
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDefault 
      Height          =   285
      Left            =   1320
      TabIndex        =   3
      Text            =   """<none>"""
      Top             =   1440
      Width           =   3375
   End
   Begin VB.TextBox txtTableName 
      BackColor       =   &H8000000F&
      Height          =   285
      Left            =   1320
      Locked          =   -1  'True
      TabIndex        =   9
      Text            =   "People"
      Top             =   360
      Width           =   3375
   End
   Begin VB.TextBox txtFieldName 
      Height          =   285
      Left            =   1320
      TabIndex        =   1
      Text            =   "NewField"
      Top             =   720
      Width           =   3375
   End
   Begin VB.ComboBox cboDataType 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   1320
      List            =   "Form1.frx":0016
      TabIndex        =   2
      Text            =   "VARCHAR(20)"
      Top             =   1080
      Width           =   1695
   End
   Begin VB.CommandButton cmdRemoveField 
      Caption         =   "Remove Field"
      Height          =   375
      Left            =   1560
      TabIndex        =   5
      Top             =   1920
      Width           =   1455
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   1320
      TabIndex        =   0
      Top             =   0
      Width           =   3375
   End
   Begin VB.CommandButton cmdAddField 
      Caption         =   "Add Field"
      Height          =   375
      Left            =   0
      TabIndex        =   4
      Top             =   1920
      Width           =   1455
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Default"
      Height          =   195
      Index           =   4
      Left            =   0
      TabIndex        =   11
      Top             =   1440
      Width           =   510
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Table Name"
      Height          =   195
      Index           =   3
      Left            =   0
      TabIndex        =   10
      Top             =   360
      Width           =   870
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Data Type"
      Height          =   195
      Index           =   2
      Left            =   0
      TabIndex        =   8
      Top             =   1080
      Width           =   750
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Field Name"
      Height          =   195
      Index           =   1
      Left            =   0
      TabIndex        =   7
      Top             =   720
      Width           =   795
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Database Name"
      Height          =   195
      Index           =   0
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   1155
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdAddField_Click()
Dim conn As ADODB.Connection
Dim cat As ADOX.Catalog
Dim tbl As ADOX.Table
Dim col As ADOX.Column
Dim data_type As String
Dim data_type_enum As DataTypeEnum
Dim field_len As Integer
Dim pos As Integer

    ' Open the connection.
    Set conn = New ADODB.Connection
    conn.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Persist Security Info=False;" & _
        "Data Source=" & txtDatabase.Text
    conn.Open

    ' Make a catalog for the database.
    Set cat = New ADOX.Catalog
    Set cat.ActiveConnection = conn

    ' Get the table.
    Set tbl = cat.Tables(txtTableName.Text)

    ' Create the field.
    Set col = New ADOX.Column
    col.Name = txtFieldName.Text
    pos = InStr(cboDataType.Text, "(")
    If pos < 1 Then
        data_type = cboDataType.Text
    Else
        data_type = Left$(cboDataType.Text, pos - 1)
        field_len = CInt(Mid$(cboDataType.Text, pos + 1, Len(cboDataType.Text) - pos - 1))
    End If
    Select Case data_type
        Case "INTEGER"
            col.Type = adInteger
        Case "FLOAT"
            col.Type = adDouble
        Case "REAL"
            col.Type = adSingle
        Case "VARCHAR"
            col.Type = adVarWChar
            col.DefinedSize = field_len
        Case "CHAR"
            col.Type = adWChar
            col.DefinedSize = field_len
    End Select

    ' Add the field.
    tbl.Columns.Append col

    conn.Close
    MsgBox "Ok"
    Exit Sub

AddFieldError:
    conn.Close
    MsgBox "Error " & Err.Number & _
        " creating field" & vbCrLf & _
        Err.Description
    Exit Sub
End Sub


Private Sub cmdRemoveField_Click()
Dim conn As ADODB.Connection
Dim cat As ADOX.Catalog
Dim tbl As ADOX.Table

    ' Open the connection.
    Set conn = New ADODB.Connection
    conn.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Persist Security Info=False;" & _
        "Data Source=" & txtDatabase.Text
    conn.Open

    ' Make a catalog for the database.
    Set cat = New ADOX.Catalog
    Set cat.ActiveConnection = conn

    ' Get the table.
    Set tbl = cat.Tables(txtTableName.Text)

    ' Drop the field.
    tbl.Columns.Delete (txtFieldName.Text)

    conn.Close
    MsgBox "Ok"
    Exit Sub

DropFieldError:
    conn.Close
    MsgBox "Error " & Err.Number & _
        " creating field" & vbCrLf & _
        Err.Description
    Exit Sub
End Sub

Private Sub Form_Load()
Dim db_name As String

    db_name = App.Path
    If Right$(db_name, 1) <> "\" Then db_name = db_name & "\"
    txtDatabase.Text = db_name & "People.mdb"
End Sub

Private Sub Form_Resize()
Dim wid As Single

    wid = ScaleWidth - txtDatabase.Left
    If wid < 120 Then wid = 120
    txtDatabase.Width = wid
    txtFieldName.Width = wid
    txtFieldName.Width = wid
    txtDefault.Width = wid
End Sub


